stages:
  - build
  - kaniko
  - env
  - test
  - staging
  - production

# TODO: Remove 'kaniko' and 'env' stage, make those jobs run in parallal with build/test

# build
build:
  stage: build
  script:
    - echo "This is some text" > my_file.txt
  artifacts:
    paths:
      - my_file.txt
    # If not set, use default expiration
    expire_in: 1 week

kaniko build:
  # TODO: Make run in parallel with build
  stage: kaniko
  script:
    - echo "filler text"
# END build

# test
env:
  # TODO: Make run in parallel with test
  stage: env
  script:
    - env

test:
  stage: test
  before_script:
    - TXT_RED="\e[31m" && TXT_CLEAR="\e[0m"
    - echo "download stuff"
  script:
    - echo "dummy test"
    - echo -e "${TXT_RED}This text is red,${TXT_CLEAR} but this part isn't${TXT_RED} however this part is again."
# END test

# Stage deploy
staging deploy:
  stage: staging
  # TODO: Add build timeout (https://docs.gitlab.com/ee/ci/yaml/#timeout)
  script:
    - echo "dummy deploy staging"
  after_script:
    - echo "dummy validate staging deploy"
# END stage deploy

# Prod deploy
production deploy:
  stage: production
  when: manual
  allow_failure: false
  script:
    - echo "dummy deploy production"
  after_script:
    - echo "dummy validate production deploy"
# END prod deploy

post success:
  stage: .post
  when: on_success
  script:
    - echo "notify success!"

post failure:
  stage: .post
  when: on_failure
  script:
    - echo "notify failure"

